import peasy.*;

PeasyCam cam;

PVector p1 = new PVector(0,0,0);
PVector p2 = new PVector(100,0,0); 
PVector p3 = new PVector(100,100,100); 

void setup()
{
  // set the window size + 3d mode
  size(800, 600, P3D);

  // setup the camera
  cam = new PeasyCam(this, 1500);
  cam.setMinimumDistance(5);
  cam.setMaximumDistance(5000);
  perspective(radians(25), (float)width / (float)height, .1, 5000);
  
}

void draw()
{
  background(0);

  coordSys(100);

  // draw triangle
  stroke(255, 0, 150);
  beginShape(TRIANGLES);
  vertex(p1.x, p1.y, p1.z);
  vertex(p2.x, p2.y, p2.z);
  vertex(p3.x, p3.y, p3.z);
  endShape();
  
  PVector normal = getPlaneNormal(p1,p2,p3);
  normal.mult(50);  // make it bigger(length of 50) to see better
  
  stroke(255, 255, 50);
  beginShape(LINES);
  vertex(p1.x, p1.y, p1.z);
  vertex(p1.x + normal.x, p1.y + normal.y, p1.z + normal.z);

  vertex(p2.x, p2.y, p2.z);
  vertex(p2.x + normal.x, p2.y + normal.y, p2.z + normal.z);

  vertex(p3.x, p3.y, p3.z);
  vertex(p3.x + normal.x, p3.y + normal.y, p3.z + normal.z);
  endShape();

}

PVector getPlaneNormal(PVector p1, PVector p2, PVector p3)
{
  PVector u = PVector.sub(p2, p1);
  PVector v = PVector.sub(p3, p1);

  PVector ret = PVector.cross(u, v, null);
  ret.normalize();
  return ret;
}


// draws a simple coordinate system
void coordSys(float size)
{
  pushStyle();

  stroke(255, 0, 0);
  line(0, 0, 0, 
  size, 0, 0);

  stroke(0, 255, 0);
  line(0, 0, 0, 
  0, size, 0);

  stroke(0, 0, 255);
  line(0, 0, 0, 
  0, 0, size);

  popStyle();
}
